Index: src/Views/StringView.hpp
===================================================================
--- src/Views/StringView.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Views/StringView.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -12,6 +12,4 @@
 #include "Views/View.hpp"
 
-using namespace std;
-
 /**
  * View to show something as a string
@@ -26,5 +24,5 @@
   virtual ~StringView();
 
-  virtual const string toString()=0;
+  virtual const std::string toString()=0;
 };
 
Index: src/World.cpp
===================================================================
--- src/World.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/World.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -9,7 +9,15 @@
 
 #include "atom.hpp"
+#include "config.hpp"
 #include "molecule.hpp"
 #include "periodentafel.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
+#include "Descriptors/AtomDescriptor_impl.hpp"
+#include "Descriptors/MoleculeDescriptor.hpp"
+#include "Descriptors/MoleculeDescriptor_impl.hpp"
+#include "Descriptors/SelectiveIterator_impl.hpp"
+#include "Actions/ManipulateAtomsProcess.hpp"
+
+#include "Patterns/Singleton_impl.hpp"
 
 using namespace std;
@@ -20,4 +28,10 @@
 }
 
+config *&World::getConfig(){
+  return configuration;
+}
+
+// Atoms
+
 atom* World::getAtom(AtomDescriptor descriptor){
   return descriptor.find();
@@ -28,36 +42,250 @@
 }
 
+vector<atom*> World::getAllAtoms(){
+  return getAllAtoms(AllAtoms());
+}
+
 int World::numAtoms(){
   return atoms.size();
 }
 
+// Molecules
+
+molecule *World::getMolecule(MoleculeDescriptor descriptor){
+  return descriptor.find();
+}
+
+std::vector<molecule*> World::getAllMolecules(MoleculeDescriptor descriptor){
+  return descriptor.findAll();
+}
+
 int World::numMolecules(){
   return molecules_deprecated->ListOfMolecules.size();
 }
 
+// system
+
+double * World::getDomain() {
+  return cell_size;
+}
+
+void World::setDomain(double * matrix)
+{
+
+}
+
+char * World::getDefaultName() {
+  return defaultName;
+}
+
+void World::setDefaultName(char * name)
+{
+  delete[](defaultName);
+  const int length = strlen(name);
+  defaultName = new char[length+2];
+  if (length < MAXSTRINGSIZE)
+    strncpy(defaultName, name, length);
+  else
+    strcpy(defaultName, "none");
+};
+
+
+/******************** Methods to change World state *********************/
+
 molecule* World::createMolecule(){
   OBSERVE;
   molecule *mol = NULL;
-  mol = new molecule(periode);
-  molecules_deprecated->insert(mol);
-  molecules.insert(mol);
+  mol = NewMolecule();
+  assert(!molecules.count(currMoleculeId));
+  mol->setId(currMoleculeId++);
+  // store the molecule by ID
+  molecules[mol->getId()] = mol;
   mol->signOn(this);
   return mol;
 }
 
+void World::destroyMolecule(molecule* mol){
+  OBSERVE;
+  destroyMolecule(mol->getId());
+}
+
+void World::destroyMolecule(moleculeId_t id){
+  OBSERVE;
+  molecule *mol = molecules[id];
+  assert(mol);
+  DeleteMolecule(mol);
+  molecules.erase(id);
+}
+
+double *World::cell_size = NULL;
+char *World::defaultName = NULL;
+
+atom *World::createAtom(){
+  OBSERVE;
+  atomId_t id = getNextAtomId();
+  atom *res = NewAtom(id);
+  res->setWorld(this);
+  // store the atom by ID
+  atoms[res->getId()] = res;
+  return res;
+}
+
+
+int World::registerAtom(atom *atom){
+  OBSERVE;
+  atomId_t id = getNextAtomId();
+  atom->setId(id);
+  atom->setWorld(this);
+  atoms[atom->getId()] = atom;
+  return atom->getId();
+}
+
+void World::destroyAtom(atom* atom){
+  OBSERVE;
+  int id = atom->getId();
+  destroyAtom(id);
+}
+
+void World::destroyAtom(atomId_t id) {
+  OBSERVE;
+  atom *atom = atoms[id];
+  assert(atom);
+  DeleteAtom(atom);
+  atoms.erase(id);
+  releaseAtomId(id);
+}
+
+bool World::changeAtomId(atomId_t oldId, atomId_t newId, atom* target){
+  OBSERVE;
+  // in case this call did not originate from inside the atom, we redirect it,
+  // to also let it know that it has changed
+  if(!target){
+    target = atoms[oldId];
+    assert(target && "Atom with that ID not found");
+    return target->changeId(newId);
+  }
+  else{
+    if(reserveAtomId(newId)){
+      atoms.erase(oldId);
+      atoms.insert(pair<atomId_t,atom*>(newId,target));
+      return true;
+    }
+    else{
+      return false;
+    }
+  }
+}
+
+ManipulateAtomsProcess* World::manipulateAtoms(boost::function<void(atom*)> op,std::string name,AtomDescriptor descr){
+  return new ManipulateAtomsProcess(op, descr,name,true);
+}
+
+ManipulateAtomsProcess* World::manipulateAtoms(boost::function<void(atom*)> op,std::string name){
+  return manipulateAtoms(op,name,AllAtoms());
+}
+
+/********************* Internal Change methods for double Callback and Observer mechanism ********/
+
+void World::doManipulate(ManipulateAtomsProcess *proc){
+  proc->signOn(this);
+  {
+    OBSERVE;
+    proc->doManipulate(this);
+  }
+  proc->signOff(this);
+}
+/******************************* IDManagement *****************************/
+
+// Atoms
+
+atomId_t World::getNextAtomId(){
+  // see if we can reuse some Id
+  if(atomIdPool.empty()){
+    return currAtomId++;
+  }
+  else{
+    // we give out the first ID from the pool
+    atomId_t id = *(atomIdPool.begin());
+    atomIdPool.erase(id);
+    return id;
+  }
+}
+
+void World::releaseAtomId(atomId_t id){
+  atomIdPool.insert(id);
+  // defragmentation of the pool
+  set<atomId_t>::reverse_iterator iter;
+  // go through all Ids in the pool that lie immediately below the border
+  while(!atomIdPool.empty() && *(atomIdPool.rbegin())==(currAtomId-1)){
+    atomIdPool.erase(--currAtomId);
+  }
+}
+
+bool World::reserveAtomId(atomId_t id){
+  if(id>=currAtomId ){
+    // add all ids between the new one and current border as available
+    for(atomId_t pos=currAtomId; pos<id; ++pos){
+      atomIdPool.insert(pos);
+    }
+    currAtomId=id+1;
+    return true;
+  }
+  else if(atomIdPool.count(id)){
+    atomIdPool.erase(id);
+    return true;
+  }
+  else{
+    // this ID could not be reserved
+    return false;
+  }
+}
+
+// Molecules
+
+/******************************* Iterators ********************************/
+
+// Build the AtomIterator from template
+CONSTRUCT_SELECTIVE_ITERATOR(atom*,World::AtomSet,AtomDescriptor);
+
+
+World::AtomIterator World::getAtomIter(AtomDescriptor descr){
+  return AtomIterator(descr,atoms);
+}
+
+World::AtomIterator World::atomEnd(){
+  return AtomIterator(AllAtoms(),atoms,atoms.end());
+}
+
+// build the MoleculeIterator from template
+CONSTRUCT_SELECTIVE_ITERATOR(molecule*,World::MoleculeSet,MoleculeDescriptor);
+
+World::MoleculeIterator World::getMoleculeIter(MoleculeDescriptor descr){
+  return MoleculeIterator(descr,molecules);
+}
+
+World::MoleculeIterator World::moleculeEnd(){
+  return MoleculeIterator(AllMolecules(),molecules,molecules.end());
+}
 
 /******************************* Singleton Stuff **************************/
 
-// TODO: Hide boost-thread using Autotools stuff when no threads are used
-World* World::theWorld = 0;
-boost::mutex World::worldLock;
-
-
-
 World::World() :
-    dummyId(0),
     periode(new periodentafel),
-    molecules_deprecated(new MoleculeListClass)
+    configuration(new config),
+    atoms(),
+    currAtomId(0),
+    molecules(),
+    currMoleculeId(0),
+    molecules_deprecated(new MoleculeListClass(this))
 {
+  cell_size = new double[6];
+  cell_size[0] = 20.;
+  cell_size[1] = 0.;
+  cell_size[2] = 20.;
+  cell_size[3] = 0.;
+  cell_size[4] = 0.;
+  cell_size[5] = 20.;
+  defaultName = new char[MAXSTRINGSIZE];
+  strcpy(defaultName, "none");
   molecules_deprecated->signOn(this);
 }
@@ -65,52 +293,25 @@
 World::~World()
 {
+  molecules_deprecated->signOff(this);
+  delete[] cell_size;
+  delete[] defaultName;
+  delete molecules_deprecated;
   delete periode;
-}
-
-World* World::get(){
-  // boost supports RAII-Style locking, so we don't need to unlock
-  boost::mutex::scoped_lock guard(worldLock);
-  if(!theWorld) {
-    theWorld = new World();
-  }
-  return theWorld;
-}
-
-void World::destroy(){
-  // For legacy reasons all atoms have to be destroyed first, since unregistering would cause deadlocks otherwise
-  theWorld->destroyLegacy();
-  //WARNING: at this point we have a small race condition, when sombody now tries to access the world.
-
-  // boost supports RAII-Style locking, so we don't need to unlock
-  boost::mutex::scoped_lock guard(worldLock);
-  delete theWorld;
-  theWorld = 0;
-}
-
-World* World::reset(){
-  // For legacy reasons all atoms have to be destroyed first, since unregistering would cause deadlocks otherwise
-  theWorld->destroyLegacy();
-  //WARNING: at this point we have a small race condition, when sombody now tries to access the world.
-
-  World* oldWorld = 0;
-  {
-    // boost supports RAII-Style locking, so we don't need to unlock
-    boost::mutex::scoped_lock guard(worldLock);
-
-    oldWorld = theWorld;
-    theWorld = new World();
-    // oldworld does not need protection any more,
-    // since we should have the only reference
-
-    // worldLock handles access to the pointer,
-    // not to the object
-  } // scope-end releases the lock
-
-  // we have to let all the observers know that the
-  // oldWorld was destroyed. oldWorld calls subjectKilled
-  // upon destruction. Every Observer getting that signal
-  // should see that it gets the updated new world
-  delete oldWorld;
-}
+  delete configuration;
+  MoleculeSet::iterator molIter;
+  for(molIter=molecules.begin();molIter!=molecules.end();++molIter){
+    DeleteMolecule((*molIter).second);
+  }
+  molecules.clear();
+  AtomSet::iterator atIter;
+  for(atIter=atoms.begin();atIter!=atoms.end();++atIter){
+    DeleteAtom((*atIter).second);
+  }
+  atoms.clear();
+}
+
+// Explicit instantiation of the singleton mechanism at this point
+
+CONSTRUCT_SINGLETON(World)
 
 /******************************* deprecated Legacy Stuff ***********************/
@@ -119,17 +320,2 @@
   return molecules_deprecated;
 }
-
-// some legacy stuff to let the World know about items created outside
-void World::registerAtom(atom *theAtom){
-  OBSERVE;
-  atoms[dummyId++] = theAtom;
-}
-
-void World::destroyLegacy(){
-  //delete molecules_deprecated;
-}
-
-void World::unregisterAtom(atom *theAtom){
-  OBSERVE;
-  atoms.erase(theAtom->getId());
-}
Index: src/World.hpp
===================================================================
--- src/World.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/World.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -9,13 +9,26 @@
 #define WORLD_HPP_
 
-#include <boost/thread.hpp>
+/*********************************************** includes ***********************************/
+
+#include <string>
 #include <map>
 #include <vector>
 #include <set>
-
+#include <boost/thread.hpp>
+#include <boost/shared_ptr.hpp>
+
+#include "types.hpp"
+#include "Descriptors/SelectiveIterator.hpp"
 #include "Patterns/Observer.hpp"
 #include "Patterns/Cacheable.hpp"
+#include "Patterns/Singleton.hpp"
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 // forward declarations
+class config;
 class periodentafel;
 class MoleculeListClass;
@@ -24,41 +37,229 @@
 class AtomDescriptor;
 class AtomDescriptor_impl;
-
-class World : public Observable
+class MoleculeDescriptor;
+class MoleculeDescriptor_impl;
+class ManipulateAtomsProcess;
+template<typename T>
+class AtomsCalculation;
+
+/****************************************** forward declarations *****************************/
+
+/********************************************** Class World *******************************/
+
+class World : public Singleton<World>, public Observable
 {
+
+// Make access to constructor and destructor possible from inside the singleton
+friend class Singleton<World>;
+
+// necessary for coupling with descriptors
 friend class AtomDescriptor_impl;
+friend class AtomDescriptor;
+friend class MoleculeDescriptor_impl;
+friend class MoleculeDescriptor;
+
+// Actions, calculations etc associated with the World
+friend class ManipulateAtomsProcess;
+template<typename> friend class AtomsCalculation;
 public:
+
+  // Types for Atom and Molecule structures
+  typedef std::map<atomId_t,atom*> AtomSet;
+  typedef std::map<moleculeId_t,molecule*> MoleculeSet;
 
   /***** getter and setter *****/
   // reference to pointer is used for legacy reason... reference will be removed latter to keep encapsulation of World object
+  /**
+   * returns the periodentafel for the world.
+   */
   periodentafel *&getPeriode();
+
+  /**
+   * returns the configuration for the world.
+   */
+  config *&getConfig();
+
+  /**
+   * returns the first atom that matches a given descriptor.
+   * Do not rely on ordering for descriptors that match more than one atom.
+   */
   atom* getAtom(AtomDescriptor descriptor);
+
+  /**
+   * returns a vector containing all atoms that match a given descriptor
+   */
   std::vector<atom*> getAllAtoms(AtomDescriptor descriptor);
+  std::vector<atom*> getAllAtoms();
+
+  /**
+   * returns a calculation that calls a given function on all atoms matching a descriptor.
+   * the calculation is not called at this point and can be used as an action, i.e. be stored in
+   * menus, be kept around for later use etc.
+   */
+  template<typename T> AtomsCalculation<T>* calcOnAtoms(boost::function<T(atom*)>,std::string,AtomDescriptor);
+  template<typename T> AtomsCalculation<T>* calcOnAtoms(boost::function<T(atom*)>,std::string);
+
+  /**
+   * get the number of atoms in the World
+   */
   int numAtoms();
+
+  /**
+   * returns the first molecule that matches a given descriptor.
+   * Do not rely on ordering for descriptors that match more than one molecule.
+   */
+  molecule *getMolecule(MoleculeDescriptor descriptor);
+
+  /**
+   * returns a vector containing all molecules that match a given descriptor
+   */
+  std::vector<molecule*> getAllMolecules(MoleculeDescriptor descriptor);
+
+  /**
+   * get the number of molecules in the World
+   */
   int numMolecules();
 
+  /**
+   * get the domain size as a symmetric matrix (6 components)
+   */
+  double * getDomain();
+
+  /**
+   * set the domain size as a symmetric matrix (6 components)
+   */
+  void setDomain(double * matrix);
+
+  /**
+   * get the default name
+   */
+  char * getDefaultName();
+
+  /**
+   * set the default name
+   */
+  void setDefaultName(char * name);
+
   /***** Methods to work with the World *****/
+
+  /**
+   * create a new molecule. This method should be used whenever any kind of molecule is needed. Assigns a unique
+   * ID to the molecule and stores it in the World for later retrieval. Do not create molecules directly.
+   */
   molecule *createMolecule();
-private:
+
+  void destroyMolecule(molecule*);
+  void destroyMolecule(moleculeId_t);
+
+  /**
+   * Create a new atom. This method should be used whenever any atom is needed. Assigns a unique ID and stores
+   * the atom in the World. If the atom is not destroyed it will automatically be destroyed when the world ends.
+   */
+  atom *createAtom();
+
+  /**
+   * Registers a Atom unknown to world. Needed in some rare cases, e.g. when cloning atoms, or in some unittests.
+   * Do not re-register Atoms already known to the world since this will cause double-frees.
+   */
+  int registerAtom(atom*);
+
+  /**
+     * Delete some atom and erase it from the world. Use this whenever you need to destroy any atom. Do not call delete on
+     * atom directly since this will leave the pointer inside the world.
+   */
+  void destroyAtom(atom*);
+
+  /**
+   * Delete some atom and erase it from the world. Use this whenever you need to destroy any atom. Do not call delete on
+   * atom directly since this will leave the pointer inside the world.
+   */
+  void destroyAtom(atomId_t);
+
+  /**
+   * used when changing an atom Id.
+   * Unless you are calling this method from inside an atom don't fiddle with the third parameter.
+   *
+   * Return value indicates wether the change could be done or not.
+   */
+  bool changeAtomId(atomId_t oldId, atomId_t newId, atom* target=0);
+
+  /**
+   * Produces a process that calls a function on all Atoms matching a given descriptor. The process is not
+   * called at this time, so it can be passed around, stored inside menuItems etc.
+   */
+  ManipulateAtomsProcess* manipulateAtoms(boost::function<void(atom*)>,std::string,AtomDescriptor);
+  ManipulateAtomsProcess* manipulateAtoms(boost::function<void(atom*)>,std::string);
+
+protected:
+  /**** Iterators to use internal data structures */
+
+  // Atoms
+  typedef SelectiveIterator<atom*,AtomSet,AtomDescriptor> AtomIterator;
+
+  /**
+   * returns an iterator over all Atoms matching a given descriptor.
+   * used for internal purposes, like AtomProcesses and AtomCalculations.
+   */
+  AtomIterator getAtomIter(AtomDescriptor descr);
+
+  /**
+   * returns an iterator to the end of the AtomSet. Due to overloading this iterator
+   * can be compared to iterators produced by getAtomIter (see the mis-matching types).
+   * Thus it can be used to detect when such an iterator is at the end of the list.
+   * used for internal purposes, like AtomProcesses and AtomCalculations.
+   */
+  AtomIterator atomEnd();
+
+  // Molecules
+
+  typedef SelectiveIterator<molecule*,MoleculeSet,MoleculeDescriptor> MoleculeIterator;
+
+  /**
+   * returns an iterator over all Molecules matching a given descriptor.
+   * used for internal purposes, like MoleculeProcesses and MoleculeCalculations.
+   */
+  MoleculeIterator getMoleculeIter(MoleculeDescriptor descr);
+
+  /**
+   * returns an iterator to the end of the MoleculeSet. Due to overloading this iterator
+   * can be compared to iterators produced by getMoleculeIter (see the mis-matching types).
+   * Thus it can be used to detect when such an iterator is at the end of the list.
+   * used for internal purposes, like MoleculeProcesses and MoleculeCalculations.
+   */
+  MoleculeIterator moleculeEnd();
+
+
+  /******* Internal manipulation routines for double callback and Observer mechanism ******/
+  void doManipulate(ManipulateAtomsProcess *);
+
+private:
+
+  atomId_t getNextAtomId();
+  void releaseAtomId(atomId_t);
+  bool reserveAtomId(atomId_t);
+
   periodentafel *periode;
-  std::map<int,atom*> atoms;
-  std::set<molecule*> molecules;
-
-
-  /***** singleton Stuff *****/
+  config *configuration;
+  static double *cell_size;
+  static char *defaultName;
 public:
-  static World* get();
-  static void destroy();
-  static World* reset();
-
-private:
+  AtomSet atoms;
+private:
+  std::set<atomId_t> atomIdPool; //<!stores the pool for all available AtomIds below currAtomId
+  atomId_t currAtomId; //!< stores the next available Id for atoms
+  MoleculeSet molecules;
+  moleculeId_t currMoleculeId;
+private:
+  /**
+   * private constructor to ensure creation of the world using
+   * the singleton pattern.
+   */
   World();
+
+  /**
+   * private destructor to ensure destruction of the world using the
+   * singleton pattern.
+   */
   virtual ~World();
-
-  static World *theWorld;
-  // this mutex only saves the singleton pattern...
-  // use other mutexes to protect internal data as well
-  // this mutex handles access to the pointer, not to the object!!!
-  static boost::mutex worldLock;
 
   /*****
@@ -68,20 +269,6 @@
   MoleculeListClass *&getMolecules();
 
-  // functions used for the WorldContent template mechanism
-  void registerAtom(atom *theAtom);
-  void unregisterAtom(atom *theAtom);
-private:
-  // this function cleans up anything that cannot be cleaned while the lock is active
-  // at a later point all these cleanups have to be moved to the World Class so the deadlock and
-  // race condition can both be avoided.
-  void destroyLegacy();
-
+private:
   MoleculeListClass *molecules_deprecated;
-
-  // this is needed to assign unique IDs to atoms... so far
-  // IDs are not assigned upon Atom creation, so we cannot query the ID
-  // during construction. By using the dummy ID we can make sure all atoms
-  // are actually stored in the map and don't overwrite each other.
-  int dummyId;
 };
 
Index: src/World_calculations.hpp
===================================================================
--- src/World_calculations.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/World_calculations.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,25 @@
+/*
+ * World_calculations.hpp
+ *
+ *  Created on: Feb 19, 2010
+ *      Author: crueger
+ */
+
+#ifndef WORLD_CALCULATIONS_HPP_
+#define WORLD_CALCULATIONS_HPP_
+
+
+#include "World.hpp"
+#include "Actions/AtomsCalculation.hpp"
+
+template<typename T>
+AtomsCalculation<T>* World::calcOnAtoms(boost::function<T(atom*)> op,std::string name,AtomDescriptor descr){
+  return new AtomsCalculation<T>(op,name,descr);
+}
+
+template<typename T>
+AtomsCalculation<T>* World::calcOnAtoms(boost::function<T(atom*)> op,std::string name) {
+  return calcOnAtoms<T>(op,name,AllAtoms());
+}
+
+#endif /* WORLD_CALCULATIONS_HPP_ */
Index: src/analysis_bonds.cpp
===================================================================
--- src/analysis_bonds.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/analysis_bonds.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -9,4 +9,6 @@
 #include "atom.hpp"
 #include "bond.hpp"
+#include "element.hpp"
+#include "info.hpp"
 #include "log.hpp"
 #include "molecule.hpp"
@@ -37,5 +39,5 @@
   }
   if (((int)Mean % 2) != 0)
-    eLog() << Verbose(1) << "Something is wrong with the bond structure, the number of bonds is not even!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Something is wrong with the bond structure, the number of bonds is not even!" << endl);
   Mean /= (double)AtomCount;
 };
@@ -79,2 +81,193 @@
   }
 };
+
+/** Calculate the angle between \a *first and \a *origin and \a *second and \a *origin.
+ * \param *first first Vector
+ * \param *origin origin of angle taking
+ * \param *second second Vector
+ * \return angle between \a *first and \a *second, both relative to origin at \a *origin.
+ */
+double CalculateAngle(Vector *first, Vector *central, Vector *second)
+{
+  Vector OHBond;
+  Vector OOBond;
+
+  OHBond = (*first) - (*central);
+  OOBond = (*second) - (*central);
+  const double angle = OHBond.Angle(OOBond);
+  return angle;
+};
+
+/** Checks whether the angle between \a *Oxygen and \a *Hydrogen and \a *Oxygen and \a *OtherOxygen is less than 30 degrees.
+ * Note that distance criterion is not checked.
+ * \param *Oxygen first oxygen atom, bonded to \a *Hydrogen
+ * \param *Hydrogen hydrogen bonded to \a *Oxygen
+ * \param *OtherOxygen other oxygen atom
+ * \return true - angle criteria fulfilled, false - criteria not fulfilled, angle greater than 30 degrees.
+ */
+bool CheckHydrogenBridgeBondAngle(atom *Oxygen, atom *Hydrogen, atom *OtherOxygen)
+{
+  Info FunctionInfo(__func__);
+
+  // check angle
+  if (CalculateAngle(&Hydrogen->x, &Oxygen->x, &OtherOxygen->x) < M_PI*(30./180.)) {
+    return true;
+  } else {
+    return false;
+  }
+};
+
+/** Counts the number of hydrogen bridge bonds.
+ * With \a *InterfaceElement an extra element can be specified that identifies some boundary.
+ * Then, counting is for the h-bridges that connect to interface only.
+ * \param *molecules molecules to count bonds
+ * \param *InterfaceElement or NULL
+ */
+int CountHydrogenBridgeBonds(MoleculeListClass *molecules, element * InterfaceElement = NULL)
+{
+  atom *Walker = NULL;
+  atom *Runner = NULL;
+  int count = 0;
+  int OtherHydrogens = 0;
+  double Otherangle = 0.;
+  bool InterfaceFlag = false;
+  bool OtherHydrogenFlag = true;
+  for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin();MolWalker != molecules->ListOfMolecules.end(); MolWalker++) {
+    Walker = (*MolWalker)->start;
+    while (Walker->next != (*MolWalker)->end) {
+      Walker = Walker->next;
+      for (MoleculeList::const_iterator MolRunner = molecules->ListOfMolecules.begin();MolRunner != molecules->ListOfMolecules.end(); MolRunner++) {
+        Runner = (*MolRunner)->start;
+        while (Runner->next != (*MolRunner)->end) {
+          Runner = Runner->next;
+          if ((Walker->type->Z  == 8) && (Runner->type->Z  == 8)) {
+            // check distance
+            const double distance = Runner->x.DistanceSquared(Walker->x);
+            if ((distance > MYEPSILON) && (distance < HBRIDGEDISTANCE*HBRIDGEDISTANCE)) { // distance >0 means  different atoms
+              // on other atom(Runner) we check for bond to interface element and
+              // check that O-O line is not in between the shanks of the two connected hydrogens (Otherangle > 104.5)
+              OtherHydrogenFlag = true;
+              Otherangle = 0.;
+              OtherHydrogens = 0;
+              InterfaceFlag = (InterfaceElement == NULL);
+              for (BondList::const_iterator BondRunner = Runner->ListOfBonds.begin(); BondRunner != Runner->ListOfBonds.end(); BondRunner++) {
+                atom * const OtherAtom = (*BondRunner)->GetOtherAtom(Runner);
+                // if hydrogen, check angle to be greater(!) than 30 degrees
+                if (OtherAtom->type->Z == 1) {
+                  const double angle = CalculateAngle(&OtherAtom->x, &Runner->x, &Walker->x);
+                  OtherHydrogenFlag = OtherHydrogenFlag && (angle > M_PI*(30./180.) + MYEPSILON);
+                  Otherangle += angle;
+                  OtherHydrogens++;
+                }
+                InterfaceFlag = InterfaceFlag || (OtherAtom->type == InterfaceElement);
+              }
+              DoLog(1) && (Log() << Verbose(1) << "Otherangle is " << Otherangle << " for " << OtherHydrogens << " hydrogens." << endl);
+              switch (OtherHydrogens) {
+                case 0:
+                case 1:
+                  break;
+                case 2:
+                  OtherHydrogenFlag = OtherHydrogenFlag && (Otherangle > M_PI*(104.5/180.) + MYEPSILON);
+                  break;
+                default: // 3 or more hydrogens ...
+                  OtherHydrogenFlag = false;
+                  break;
+              }
+              if (InterfaceFlag && OtherHydrogenFlag) {
+                // on this element (Walker) we check for bond to hydrogen, i.e. part of water molecule
+                for (BondList::const_iterator BondRunner = Walker->ListOfBonds.begin(); BondRunner != Walker->ListOfBonds.end(); BondRunner++) {
+                  atom * const OtherAtom = (*BondRunner)->GetOtherAtom(Walker);
+                  if (OtherAtom->type->Z == 1) {
+                    // check angle
+                    if (CheckHydrogenBridgeBondAngle(Walker, OtherAtom, Runner)) {
+                      DoLog(1) && (Log() << Verbose(1) << Walker->Name << ", " << OtherAtom->Name << " and " << Runner->Name << " has a hydrogen bridge bond with distance " << sqrt(distance) << " and angle " << CalculateAngle(&OtherAtom->x, &Walker->x, &Runner->x)*(180./M_PI) << "." << endl);
+                      count++;
+                      break;
+                    }
+                  }
+                }
+              }
+            }
+          }
+        }
+      }
+    }
+  }
+  return count;
+}
+
+/** Counts the number of bonds between two given elements.
+ * \param *molecules list of molecules with all atoms
+ * \param *first pointer to first element
+ * \param *second pointer to second element
+ * \return number of found bonds (\a *first-\a *second)
+ */
+int CountBondsOfTwo(MoleculeListClass * const molecules, const element * const first, const element * const second)
+{
+  atom *Walker = NULL;
+  int count = 0;
+
+  for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin();MolWalker != molecules->ListOfMolecules.end(); MolWalker++) {
+    Walker = (*MolWalker)->start;
+    while (Walker->next != (*MolWalker)->end) {
+      Walker = Walker->next;
+      if ((Walker->type == first) || (Walker->type == second)) {  // first element matches
+        for (BondList::const_iterator BondRunner = Walker->ListOfBonds.begin(); BondRunner != Walker->ListOfBonds.end(); BondRunner++) {
+          atom * const OtherAtom = (*BondRunner)->GetOtherAtom(Walker);
+          if (((OtherAtom->type == first) || (OtherAtom->type == second)) && (Walker->nr < OtherAtom->nr)) {
+            count++;
+            DoLog(1) && (Log() << Verbose(1) << first->name << "-" << second->name << " bond found between " << *Walker << " and " << *OtherAtom << "." << endl);
+          }
+        }
+      }
+    }
+  }
+  return count;
+};
+
+/** Counts the number of bonds between three given elements.
+ * Note that we do not look for arbitrary sequence of given bonds, but \a *second will be the central atom and we check
+ * whether it has bonds to both \a *first and \a *third.
+ * \param *molecules list of molecules with all atoms
+ * \param *first pointer to first element
+ * \param *second pointer to second element
+ * \param *third pointer to third element
+ * \return number of found bonds (\a *first-\a *second-\a *third, \a *third-\a *second-\a *first, respectively)
+ */
+int CountBondsOfThree(MoleculeListClass * const molecules, const element * const first, const element * const second, const element * const third)
+{
+  int count = 0;
+  bool MatchFlag[2];
+  bool result = false;
+  atom *Walker = NULL;
+  const element * ElementArray[2];
+  ElementArray[0] = first;
+  ElementArray[1] = third;
+
+  for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin();MolWalker != molecules->ListOfMolecules.end(); MolWalker++) {
+    Walker = (*MolWalker)->start;
+    while (Walker->next != (*MolWalker)->end) {
+      Walker = Walker->next;
+      if (Walker->type == second) {  // first element matches
+        for (int i=0;i<2;i++)
+          MatchFlag[i] = false;
+        for (BondList::const_iterator BondRunner = Walker->ListOfBonds.begin(); BondRunner != Walker->ListOfBonds.end(); BondRunner++) {
+          atom * const OtherAtom = (*BondRunner)->GetOtherAtom(Walker);
+          for (int i=0;i<2;i++)
+            if ((!MatchFlag[i]) && (OtherAtom->type == ElementArray[i])) {
+              MatchFlag[i] = true;
+              break;  // each bonding atom can match at most one element we are looking for
+            }
+        }
+        result = true;
+        for (int i=0;i<2;i++) // gather results
+          result = result && MatchFlag[i];
+        if (result) { // check results
+          count++;
+          DoLog(1) && (Log() << Verbose(1) << first->name << "-" << second->name << "-" << third->name << " bond found at " << *Walker << "." << endl);
+        }
+      }
+    }
+  }
+  return count;
+};
Index: src/analysis_bonds.hpp
===================================================================
--- src/analysis_bonds.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/analysis_bonds.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -18,8 +18,12 @@
 #endif
 
+/*********************************************** defines ***********************************/
+
+#define HBRIDGEDISTANCE 3.5   //!< HBridge distance from PCCP Vol 10. 4802-4813
 
 /****************************************** forward declarations *****************************/
 
 class element;
+class MoleculeListClass;
 class molecule;
 
@@ -29,3 +33,7 @@
 void MinMeanMaxBondDistanceBetweenElements(const molecule *mol, element *type1, element *type2, double &Min, double &Mean, double &Max);
 
+int CountHydrogenBridgeBonds(MoleculeListClass * const molecules, element * InterfaceElement);
+int CountBondsOfTwo(MoleculeListClass * const molecules, const element * const first, const element * const second);
+int CountBondsOfThree(MoleculeListClass * const molecules, const element * const first, const element * const second, const element * const third);
+
 #endif /* ANALYSIS_BONDS_HPP_ */
